@echo off
echo -----------------------------------
echo -----Generating Installers of------
echo -----creaThirdPartyLibraries-------
echo -----------------------------------
echo -----------------------------------
echo ------Asking Architecture----------
echo -----------------------------------
if %PROCESSOR_ARCHITECTURE%==x86 (
  set ProgramFilesPath_x86=%ProgramFiles%
  echo "Architecture found = x86"
) else (
  set "ProgramFilesPath_x86=%ProgramFiles(x86)%"
  echo "Architecture found = x64"
)

echo ----End Asking Architecture--------

set thirdpartyGeneration=%1
set buildType=%2
::The following line is to force x86 or x64 compilation
set x86Comp=%3

set thirdparty_cmake=%cd%\..\cmake

set vcvarsall="%ProgramFilesPath_x86%\Microsoft Visual Studio 10.0\VC\vcvarsall.bat"

set thirdpartylibpath=%thirdpartyGeneration%\thirdparty_temp\creaThirdParty_libraries
set sourcepath=%thirdparty_cmake%\crea_ThirdParty_Libraries
set binpath=%thirdpartyGeneration%\thirdparty_bin\%buildType%\creaTPLBin

if not exist %vcvarsall% set zipPath="%ProgramFilesPath_x64%\Microsoft Visual Studio 10.0\VC\vcvarsall.bat"
if not exist %vcvarsall% (
  echo ERROR!!! Visual Studio has not been found in the system
  exit
)

if %x86Comp%==ON (
	call %vcvarsall%
	echo "Compilation forced x86"
) else (
	if %PROCESSOR_ARCHITECTURE%==x86 (
		set installpath="%ProgramFilesPath_x86%\creatools\crea_ThirdParty_Libraries"
		call %vcvarsall%
	) else (
		set installpath="%ProgramFiles%\creatools\crea_ThirdParty_Libraries"
		call %vcvarsall% amd64
	)
)

rmdir /S /Q %binpath%
mkdir %binpath%
cd %binpath%

if %x86Comp%==ON (
	set buildPlatform=win32
	cmake -G"Visual Studio 10"  -H%sourcepath% -B%binpath%
) else (
	if %PROCESSOR_ARCHITECTURE%==x86 (
   	    set buildPlatform=win32
		cmake -G"Visual Studio 10"  -H%sourcepath% -B%binpath%
	) else (
  	    set buildPlatform=win64
		cmake -G"Visual Studio 10 Win64"  -H%sourcepath% -B%binpath%
	)
)

cmake -D CREATOOLS_BUILDTYPE:STRING=%buildType% -D CREATOOLS_PLATFORM:STRING=%buildPlatform%  CMakeCache.txt
cmake -D CMAKE_INSTALL_PREFIX:PATH=%installpath% CMakeCache.txt
cmake -D CREA_LIBRARY_SOURCE_PATH:PATH=%thirdpartylibpath% CMakeCache.txt
cmake CMakeCache.txt
FOR /R %%a IN (*.sln) DO msbuild %%a /m:%NUMBER_OF_PROCESSORS% /p:UseEnv=true;BuildInParallel=true;Configuration=%buildType%
msbuild /m:%NUMBER_OF_PROCESSORS% /p:UseEnv=true;BuildInParallel=true;Configuration=%buildType% PACKAGE.vcxproj

exit /B